<template>
    <form v-on:submit.prevent="submitForm">
        <div>
            <label>Title</label>
            <input type="text" v-model="title"/>
            <label v-if="errors.title">{{errors.title}}</label>
        </div>
        <div>
            <label>Description</label>
            <input type="text" v-model="description"/>
        </div>
        <div>
            <label>Type</label>
            <select name="type" v-model="type">
                <option value="BUG">BUG</option>
                <option value="FEATURE">FEATURE</option>
            </select>
            <label v-if="errors.type">{{errors.type}}</label>
        </div>
        <div>
            <label>Status</label>
            <select name="status" v-model="status" :value="status">
                <option value="TODO">TO DO</option>
                <option value="INPROGRESS">IN PROGRESS</option>
                <option value="INREVIEW">IN REVIEW</option>
                <option value="DONE">DONE</option>
            </select>
        </div>
        <div>
            <label>Priority</label>
            <select name="priority" v-model="priority">
                <option value="LOW">LOW</option>
                <option value="MEDIUM">MEDIUM</option>
                <option value="HIGH">HIGH</option>
            </select>
        </div>
        <div>
            <label>Assigned To</label>
            <select name="assignedTo" v-model="assignedTo">
                <option v-for="user in users" :key="user.id" :value="user.id">
                    {{ user.firstname +' '+user.lastname}}
                </option>
            </select>
        </div>
        <div>
            <label>Creator</label>
            <select name="creator" v-model="creator">
                <option v-for="user in users" :key="user.id" :value="user.id">
                    {{ user.firstname +' '+user.lastname}}
                </option>
            </select>
        </div>
        <div>
            <label>point</label>
            <input type="number" v-model="point" name="point"/>
        </div>
        <button type="submit">Validate</button>
    </form>
</template>

<script>
  import UserService from '@/services/user';
  import { v4 } from 'uuid';

  export default {
    name: "FormTicket",
    props : {
      submitCallback : Function,
      ticket: Object
    },
    async beforeCreate(){
      this.users = await UserService.getUsers();
    },
    data(){
      return {
        users : null,
        errors : {},
        id :  this.ticket.id || null,
        ticketNumber :  this.ticket.ticketNumber || null,
        title :  this.ticket.title || null,
        description :  this.ticket.description || null,
        status :  this.ticket.status || 'TODO',
        assignedTo :  this.ticket.assignedTo || null,
        creator :  this.ticket.creator || null,
        type :  this.ticket.type || null,
        priority :  this.ticket.priority || null,
        point :  this.ticket.point || null,
        createdDate :  this.ticket.createdDate || null,
      }
    },
    methods : {
      submitForm() {
        this.errors = {};

        if(!this.title) this.errors.title = 'Title is required';
        if(!this.type) this.errors.type = 'Type is required';
        if(!this.creator) this.errors.creator = 'creator is required';

        if(!Object.values(this.errors).length){
          const ticket = {
            id : this.id ? this.id : v4(),
            ticketNumber: this.ticketNumber ? this.ticketNumber : Math.floor(Math.random() * 500) + 100,
            title : this.title,
            description : this.description,
            status : this.status,
            assignedTo : this.assignedTo,
            creator : this.creator,
            type : this.type,
            priority : this.priority,
            point : this.point,
            createDate : new Date(),
          };
          this.submitCallback(ticket);
        }
      }
    }
  }
</script>

<style scoped>

</style>